"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var util = require("../utils");
var FieldOptionEditor = (function (_super) {
    __extends(FieldOptionEditor, _super);
    function FieldOptionEditor() {
        var _this = _super.call(this) || this;
        _this.onOptionChanged = _this.onOptionChanged.bind(_this);
        return _this;
    }
    FieldOptionEditor.prototype.render = function () {
        var field = this.props.field;
        if (!field) {
            return React.createElement("div", null);
        }
        var fieldDef = this.props.registry[field.type];
        if (!fieldDef || !fieldDef.editor) {
            console.warn('Field defintion is not registered: ' + field.type);
            return React.createElement("div", null);
        }
        var context = {
            fields: util.getFieldSiblings(field, this.props.fields)
        };
        var optionEditorProps = {
            field: field,
            fieldContext: context,
            onChange: this.onOptionChanged
        };
        var component = React.createElement(fieldDef.editor, optionEditorProps);
        return (React.createElement("div", { className: 'field-option-editor' }, component));
    };
    FieldOptionEditor.prototype.onOptionChanged = function (field) {
        var fields = util.updateField(this.props.field, field, this.props.fields);
        if (!fields) {
            console.warn('cannot update field inside fields.', this.props.field, this.props.fields);
        }
        else {
            this.props.onChange(field, fields);
        }
    };
    return FieldOptionEditor;
}(React.PureComponent));
exports.FieldOptionEditor = FieldOptionEditor;
