/// <reference types="react" />
import * as React from 'react';
import * as data from '../data';
export interface IFormBuilderProps {
    fields: data.IField[];
    registry: data.FieldRegistry;
    onChange: (fields: data.IField[], change: data.IFieldChange) => void;
    onFieldEditing: (field: data.IField) => void;
    onBeforeAddField?: (field: data.IField) => boolean;
    onBeforeDeleteField?: (field: data.IField) => boolean;
    onBeforeEditField?: (field: data.IField) => boolean;
    editButton?: data.IEditableControlSource;
    deleteButton?: data.IEditableControlSource;
    editingField: data.IField;
}
export declare class FormBuilder extends React.Component<IFormBuilderProps, {}> {
    constructor(props: IFormBuilderProps);
    private onEditField(field);
    private onDeleteField(index);
    private onDrop(target, source, didDrop);
    private onFieldChanged(field, index, change);
    private renderField(field, index);
    render(): JSX.Element;
}
