"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classNames = require("classnames");
// FormBuilderEditable is a wrapper component that will wrap a field and display controls
// for editing and deleting a field.
var FormBuilderEditable = (function (_super) {
    __extends(FormBuilderEditable, _super);
    function FormBuilderEditable() {
        var _this = _super.call(this) || this;
        _this.onEdit = _this.onEdit.bind(_this);
        _this.onDelete = _this.onDelete.bind(_this);
        _this.onClicked = _this.onClicked.bind(_this);
        return _this;
    }
    FormBuilderEditable.prototype.onEdit = function (event) {
        event.stopPropagation();
        event.preventDefault();
        this.props.onEdit(this.props.field);
    };
    FormBuilderEditable.prototype.onDelete = function (event) {
        event.stopPropagation();
        event.preventDefault();
        this.props.onDelete(this.props.index);
    };
    FormBuilderEditable.prototype.onClicked = function (event) {
        event.stopPropagation();
        event.preventDefault();
        this.props.onEdit(this.props.field);
    };
    FormBuilderEditable.prototype.renderEditButton = function () {
        var source = this.props.editButton;
        if (!this.props.showEditButton) {
            return null;
        }
        if (!source || typeof source === 'string') {
            return (React.createElement("button", { className: 'form-builder-editable-button form-builder-editable-edit-button', type: 'button', onClick: this.onEdit }, source || 'Edit'));
        }
        if (React.isValidElement(source)) {
            return React.cloneElement(source, {
                onClick: this.onEdit,
                className: classNames(source.props.className, 'form-builder-editable-button form-builder-editable-edit-button'),
            });
        }
    };
    FormBuilderEditable.prototype.renderDeleteButton = function () {
        if (!this.props.showDeleteButton) {
            return null;
        }
        var source = this.props.deleteButton;
        if (!source || typeof source === 'string') {
            return (React.createElement("button", { className: 'form-builder-editable-button form-builder-editable-delete-button', type: 'button', onClick: this.onDelete }, source || 'Delete'));
        }
        if (React.isValidElement(source)) {
            return React.cloneElement(source, {
                onClick: this.onDelete,
                className: classNames(source.props.className, 'form-builder-editable-button form-builder-editable-delete-button'),
            });
        }
    };
    FormBuilderEditable.prototype.render = function () {
        var css = classNames('form-builder-editable-controls', {
            'form-builder-editing-controls': this.props.isEditing
        });
        return (React.createElement("div", { className: css, onClick: this.onClicked },
            this.renderEditButton(),
            this.renderDeleteButton(),
            this.props.children));
    };
    return FormBuilderEditable;
}(React.Component));
exports.FormBuilderEditable = FormBuilderEditable;
