"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var assign = require("object-assign");
var FormInput = (function (_super) {
    __extends(FormInput, _super);
    function FormInput(props) {
        var _this = _super.call(this, props) || this;
        _this.fieldInputs = {};
        _this.formState = {};
        _this.renderField = _this.renderField.bind(_this);
        _this.onValueChanged = _this.onValueChanged.bind(_this);
        return _this;
    }
    FormInput.prototype.renderField = function (field, index) {
        var _this = this;
        var fieldDef = this.props.registry[field.type];
        if (!fieldDef || !fieldDef.input) {
            console.warn('Field definition is not registered: ' + field.type);
            return;
        }
        var value = this.props.value[field.id];
        var fieldInputProps = {
            registry: this.props.registry,
            index: index,
            field: field,
            value: value,
            context: this.props.context,
            attempt: this.props.attempt,
            onValueChange: this.onValueChanged,
            ref: function (input) {
                _this.fieldInputs[index] = input;
            }
        };
        var component = React.createElement(fieldDef.input, fieldInputProps);
        return (React.createElement("div", { className: 'form-submission-field', key: index }, component));
    };
    FormInput.prototype.onValueChanged = function (field, value, fieldStatus) {
        var newValue = assign({}, this.props.value);
        newValue[field.id] = value;
        this.formState[field.id] = fieldStatus;
        this.fireValuesChange(newValue);
        this.props.onChange(newValue, this.formState);
    };
    FormInput.prototype.fireValuesChange = function (value) {
        var _this = this;
        this.props.fields.forEach(function (field, index) {
            var input = _this.fieldInputs[index];
            if (input && input.onValuesChanged) {
                var fieldState = input.onValuesChanged(value);
                _this.formState[field.id] = fieldState;
            }
        });
    };
    // render displays a list of fields based on the field registry.
    FormInput.prototype.render = function () {
        return (React.createElement("div", { className: 'form-submission' }, this.props.fields.map(this.renderField)));
    };
    return FormInput;
}(React.PureComponent));
FormInput.defaultProps = {
    value: {}
};
exports.FormInput = FormInput;
