"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// FieldRegistry maps field types to the class responsible for rendering the field and the class responsible for editing the field.
var FieldRegistry = (function () {
    function FieldRegistry() {
    }
    FieldRegistry.prototype.register = function (field) {
        if (this[field.type]) {
            throw new Error('Field type [' + field.type + '] has been registered already.');
        }
        this[field.type] = field;
    };
    FieldRegistry.prototype.getFields = function () {
        var fields = [];
        for (var key in this) {
            if (typeof this[key] !== "function") {
                fields.push(this[key]);
            }
        }
        return fields;
    };
    return FieldRegistry;
}());
exports.FieldRegistry = FieldRegistry;
