"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var assign = require("object-assign");
function updateField(oldField, newField, fields) {
    var index = fields.indexOf(oldField);
    if (index < 0) {
        for (var i = 0; i < fields.length; i++) {
            if (fields[i].fields) {
                var nestedFields = updateField(oldField, newField, fields[i].fields);
                if (nestedFields) {
                    index = i;
                    newField = assign({}, fields[i], {
                        fields: nestedFields
                    });
                    break;
                }
            }
        }
    }
    if (index >= 0) {
        var newFields = fields.slice();
        newFields[index] = newField;
        return newFields;
    }
    return null;
}
exports.updateField = updateField;
function getFieldSiblings(field, fields) {
    var index = fields.indexOf(field);
    if (index >= 0) {
        return fields;
    }
    for (var _i = 0, fields_1 = fields; _i < fields_1.length; _i++) {
        var f = fields_1[_i];
        if (f.fields) {
            var siblings = getFieldSiblings(field, f.fields);
            if (siblings) {
                return siblings;
            }
        }
    }
    return null;
}
exports.getFieldSiblings = getFieldSiblings;
